#ifndef	___VarPackTransArchiver_H_
#define	___VarPackTransArchiver_H_
//------------------------------------------------------------------------------
#include <InterfaceDefs.h>
#include <StorageDefs.h>
//==============================================================================
class	TIndividualInfo	// 書庫の中のファイルの情報
{
public:
	TIndividualInfo();

	int32		Ratio();								// 圧縮率を得る [パーミル]

	char		mFileName[B_FILE_NAME_LENGTH];			// ファイル名（パス付き）
	char		mFormat[B_MIME_TYPE_LENGTH];			// 圧縮形式（<ArcName>/<SubInfo>）
	int32		mCRC;									// ＣＲＣ
	int32		mOSType;								// このファイルを作成したＯＳ
	bigtime_t	mAccessTime;							// アクセス日時（1970年１月１日からのマイクロ秒）
	bigtime_t	mCreationTime;							// 作成日時
	bigtime_t	mModificationTime;						// 更新日時
	off_t		mFrozenSize;							// 圧縮サイズ（未算出の時-1）
	off_t		mOriginalSize;							// 元のサイズ
};
//==============================================================================
#endif	// ___VarPackTransArchiver_H_
