/*==============================================================================

	～～～　ＬＨＡ圧縮解凍心臓部　～～～

元のソース：

	LHa for UNIX Ver 1.14h + Ver 1.14i 差分

元のソースの著作権表示：

	lha.h		Modified		Nobutaka Watazaki
				Ver. 1.14	Soruce All chagned 1995.01.14 N.Watazaki
				Ver. 1.14i	Modified and bug fixed 2000.10.06 t.okamoto

	lha_macro.h	Modified		Nobutaka Watazaki
				Ver. 1.14	Soruce All chagned 1995.01.14 N.Watazaki
				Ver. 1.14g	modified 2000.05.06 T.OKAMOTO

	lhdir.h		Modified		Nobutaka Watazaki
				Ver. 1.14	Soruce All chagned 1995.01.14 N.Watazaki

	append.c		Modified		Nobutaka Watazaki
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	crcio.c		Modified		Nobutaka Watazaki
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	dhuf.c		Modified		H.Yoshizaki
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	extract.c	Modified		Nobutaka Watazaki
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	header.c		Modified		Nobutaka Watazaki
				Original		Y.Tagawa
				modified		1991.12.16 M.Oki
				Ver. 1.10	Symbolic Link added 1993.10.01 N.Watazaki
				Ver. 1.13b	Symbolic Link Bug Fix 1994.08.22 N.Watazaki
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki
				Ver. 1.14i	bug fixed 2000.10.06 t.okamoto

	huf.c		Modified		Nobutaka Watazaki	
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki
				Ver. 1.14i	Support LH7 & Bug Fixed 2000.10. 6	t.okamoto

	larc.c		Modified		Nobutaka Watazaki	
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	lhadd.c		Copyright (C) MCMLXXXIX Yooichi.Tagawa
				Modified		Nobutaka Watazaki	
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	lharc.c		Copyright (C) MCMLXXXIX Yooichi.Tagawa
				Modified		Nobutaka Watazaki
				Thanks to	H.Yoshizaki. (MS-DOS LHarc)
				Ver. 0.00	Original	1988.05.23  Y.Tagawa
				Ver. 0.01	Alpha Version (for 4.2BSD)	1989.05.28 Y.Tagawa
				Ver. 0.02	Alpha Version Rel.2 1989.05.29 Y.Tagawa
				Ver. 0.03	Release #3 Beta Version 1989.07.02 Y.Tagawa
				Ver. 0.03a	Debug 1989.07.03 Y.Tagawa
				Ver. 0.03b	Modified 1989.07.13 Y.Tagawa
				Ver. 0.03c	Debug (Thanks to void@rena.dit.junet) 1989.08.09 Y.Tagawa
				Ver. 0.03d	Modified (quiet and verbose) 1989.09.14 Y.Tagawa
				V1.00		Fixed 1989.09.22 Y.Tagawa
				V1.01		Bug Fixed 1989.12.25 Y.Tagawa

				DOS-Version	Original LHx V C2.01 (C) H.Yohizaki
				V2.00		UNIX Lharc + DOS LHx -> OSK LHx 1990.11.01 Momozou
				V2.01		Minor Modified 1990.11.24 Momozou

				Ver. 0.02	LHx for UNIX 1991.11.18 M.Oki
				Ver. 0.03	LHa for UNIX 1991.12.17 M.Oki
				Ver. 0.04	LHa for UNIX	beta version 1992.01.20 M.Oki
				Ver. 1.00	LHa for UNIX	Fixed 1992.03.19 M.Oki
				Ver. 1.10	for Symblic Link 1993.06.25 N.Watazaki
				Ver. 1.11	for Symblic Link	Bug Fixed 1993.08.18 N.Watazaki
				Ver. 1.12	for File Date Check 1993.10.28 N.Watazaki
				Ver. 1.13	Bug Fixed (Idicator calcurate)	1994.02.21 N.Watazaki
				Ver. 1.13a	Bug Fixed (Sym. Link delete) 1994.03.11 N.Watazaki
				Ver. 1.13b	Bug Fixed (Sym. Link delete) 1994.07.29 N.Watazaki
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki
				Ver. 1.14b,c	Bug Fixed 1996.03.07 t.okamoto
				Ver. 1.14d	Version up 1997.01.12 t.okamoto
				Ver. 1.14g	Bug Fixed 2000.05.06 t.okamoto
				Ver. 1.14i	Modified 2000.10.06 t.okamoto

	lhdir.c		Copyright (C) MCMLXXXIX Yooichi.Tagawa
				Modified		Nobutaka Watazaki
				Ver. 0.00	Original 1988.05.31 Y.Tagawa
				Ver. 0.03	Release #3 for LHarc UNIX 1988.07.02 Y.Tagawa
				Ver. 1.00	Fixed 1989.09.22 Y.Tagawa
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	lhext.c		Copyright (C) MCMLXXXIX Yooichi.Tagawa
				Modified		Nobutaka Watazaki	
				Ver. 0.00	Original 1988.05.23 Y.Tagawa
				Ver. 1.00	Fixed 1989.09.22 Y.Tagawa
				Ver. 0.03	LHa for UNIX 1991.12.17 M.Oki
				Ver. 1.12	LHa for UNIX 1993.10.01 N.Watazaki
				Ver. 1.13b	Symbolic Link Update Bug Fix 1994.06.21 N.Watazaki
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki
				Ver. 1.14e	bugfix 1999.04.30 T.Okamoto

	lhlist.c		Copyright (C) MCMLXXXIX Yooichi.Tagawa
				Modified		Nobutaka Watazaki
				Ver. 0.00	Original 1988.05.23 Y.Tagawa
				Ver. 1.00	Fixed 1989.09.22 Y.Tagawa
				Ver. 1.01	Bug Fix for month name 1989.12.25 Y.Tagawa
				Ver. 1.10	Changed list format 1993.10.01 N.Watazaki
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki
				Ver. 1.14e	Bug Fix for many problems 1999.05.25 T.Okamoto

	maketbl.c	Modified		Nobutaka Watazaki	
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	maketree.c	Modified		Nobutaka Watazaki	
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	patmatch.c	Modified		Nobutaka Watazaki	
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	shuf.c		Modified		Nobutaka Watazaki	
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki

	slide.c		Modified		Nobutaka Watazaki	
				Ver. 1.14d	Exchanging a search algorithm 1997.01.11 T.Okamoto

	util.c		Modified		Nobutaka Watazaki	
				Ver. 1.14	Source All chagned 1995.01.14 N.Watazaki
				Ver. 1.14e	Support for sfx archives 1999.05.28 T.Okamoto

ＢeＯＳ用に修正：

	Modified		by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.00		First Version 2000.12.18(Mon) by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.01		少し整理した 2000.12.25(Mon) by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.02		解凍後に Identify するようにした 2000.12.25(Mon) by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.03		エラーコード返却に関する修正 2000.12.28(Thu) by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.10		-lh0- の解凍をサポートした 2000.12.28(Thu) by ＳＨＩＮＴＡ (SHINTA)

==============================================================================*/

/*== MEMO ======================================================================
==============================================================================*/

#include "LHAKernel.h"
//------------------------------------------------------------------------------
#include <Directory.h>
#include <File.h>
#include <Mime.h>
#include <stdio.h>
#include <add/SHIDebug.h>
//==============================================================================
TLHAKernel::TLHAKernel()
{
}
//------------------------------------------------------------------------------
TLHAKernel::~TLHAKernel()
{
}
//------------------------------------------------------------------------------
unsigned short	TLHAKernel::CalcCrc(unsigned char *p,unsigned int n,TMeltInfo *oMeltInfo)
{
	oMeltInfo->mReadingSize += n;
	while ( n-- > 0) {
		UpdateCrc(*p++,oMeltInfo);
	}
	return oMeltInfo->mRealCrc;
}
//------------------------------------------------------------------------------
long	TLHAKernel::CopyFile(BPositionIO *oInSrc,BPositionIO *oOutDest,long oCopySize,int oCrcFlg,TMeltInfo *oMeltInfo)
/* ''''''''''''''''''''''''''''''
util.c::copyfile() 相当
oCrcFlg：0 = no crc, 1 = crc check, 2 = extract, 3 = append
返値：元ファイルのサイズ
   ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,, */
{
	char*			aBuf;
	unsigned short	aCrc;
	unsigned short	aXSize;
	long			aRSize = 0;

	if ( (aBuf = (char *)malloc(BUFFERSIZE)) == NULL )	// VU:new
		throw TException(B_NO_MEMORY);	//fatal_error("virtual memory exhausted.\n");
	aCrc = 0;
	while ( oCopySize > 0 ) {
		// read
		aXSize = (oCopySize > BUFFERSIZE) ? BUFFERSIZE : oCopySize;
		if ( oInSrc->Read(aBuf,aXSize) != aXSize )
			throw TException(B_ERROR);	//fatal_error("file read error\n");
		// write
		if ( oOutDest != NULL ) {
			if ( oOutDest->Write(aBuf,aXSize) != aXSize )
				throw TException(B_ERROR);	//fatal_error("file write error\n");
		}
		// calculate crc
		if ( oCrcFlg != 0 ) {
			CalcCrc((unsigned char *)aBuf,aXSize,oMeltInfo);
		}
		aRSize += aXSize;
		oCopySize -= aXSize;
	}
	free(aBuf);
	return aRSize;
}
//------------------------------------------------------------------------------
status_t	TLHAKernel::Decode(BPositionIO *oInSrc,BPositionIO *oOutDest,TMeltInfo *oMeltInfo)
/* ''''''''''''''''''''''''''''''
slide.c::decode() 相当
   ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,, */
{
	unsigned char*	aDText;
	unsigned int	aDicSiz1;
	unsigned int	aOffset;
	unsigned int	i, j, k, c;
	unsigned long	aDicSiz;

	oMeltInfo->mRealCrc = 0;
	oMeltInfo->mPrevChar = -1;
	aDicSiz = 1L << oMeltInfo->mDicBit;
	aDText = (unsigned char *)malloc(aDicSiz);	//VU:new
	if ( aDText == NULL )
		throw TException(B_NO_MEMORY);
	for ( i = 0 ; i < aDicSiz ; i++ ) {
		aDText[i] = 0x20;	//VU:memset
	}
	oMeltInfo->StartDecode(oInSrc);
	aDicSiz1 = aDicSiz-1;
	aOffset = (oMeltInfo->mHdr->MethodNum() == LARC_METHOD_NUM) ? 0x100-2 : 0x100-3;
	oMeltInfo->mCount = 0;
	oMeltInfo->mLoc = 0;
	while ( static_cast<long>(oMeltInfo->mCount) < oMeltInfo->mHdr->OriginalSize() ) {
		c = oMeltInfo->DecodeC(oInSrc);
		if ( c <= UCHAR_MAX ) {
			aDText[oMeltInfo->mLoc++] = c;
			if ( oMeltInfo->mLoc == aDicSiz ) {
				if ( WriteCrc(aDText,aDicSiz,oOutDest,oMeltInfo) != B_OK )
					throw TException(B_ERROR);
				oMeltInfo->mLoc = 0;
			}
			oMeltInfo->mCount++;
		} else {
			j = c-aOffset;
			i = (oMeltInfo->mLoc - oMeltInfo->DecodeP(oInSrc)-1) & aDicSiz1;
			oMeltInfo->mCount += j;
			for ( k = 0; k < j ; k++ ) {
				c = aDText[(i+k) & aDicSiz1];
				aDText[oMeltInfo->mLoc++] = c;
				if ( oMeltInfo->mLoc == aDicSiz ) {
					WriteCrc(aDText,aDicSiz,oOutDest,oMeltInfo);
					oMeltInfo->mLoc = 0;
				}
			}
		}
	}
	if ( oMeltInfo->mLoc != 0 ) {
		WriteCrc(aDText,oMeltInfo->mLoc,oOutDest,oMeltInfo);
	}
	free(aDText);
	return B_OK;
}
//------------------------------------------------------------------------------
int		TLHAKernel::DecodeLzhuf(BPositionIO *oInSrc,BPositionIO *oOutDest,TMeltInfo *oMeltInfo)
/* ''''''''''''''''''''''''''''''
extract.c::decode_lzhuf() 相当
   ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,, */
{
	oMeltInfo->mDicBit = 13;	// method + 8; -lh5-

	switch ( oMeltInfo->mHdr->MethodNum() ) {
	case LZHUFF0_METHOD_NUM:	// -lh0-
	case LARC4_METHOD_NUM:
		CopyFile(oInSrc,oOutDest,oMeltInfo->mHdr->OriginalSize(),2,oMeltInfo);	// VU:TLh0DecodeSet としてまとめられると良い
		break;
	case LARC_METHOD_NUM:		// -lzs-
		throw -1;	// ??:仮
		break;
	case LZHUFF1_METHOD_NUM:	// -lh1-
	case LZHUFF4_METHOD_NUM:	// -lh4-
	case LARC5_METHOD_NUM:		// -lz5-
		throw -1;	// ??:仮
		break;
	case LZHUFF6_METHOD_NUM:	// -lh6-
#ifdef SUPPORT_LH7
	case LZHUFF7_METHOD_NUM:	// -lh7-
#endif
	default:
		oMeltInfo->SetDecodeSet(new TLh5DecodeSet());
		Decode(oInSrc,oOutDest,oMeltInfo);
	}
	return oMeltInfo->mRealCrc;
}
//------------------------------------------------------------------------------
status_t	TLHAKernel::Extract(const char *oDestFolder)
/* ''''''''''''''''''''''''''''''
lhext.c::extract_one() 相当
ファイルを１つだけ解凍する
GetHeader() した時の情報にしたがって、ファイルを oDestFolder に解凍する
oDestFolder は、絶対パスで指定
返値：成功したら B_OK、失敗ならそれ以外
   ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,, */
{
	status_t	aResult;
	string		aDestFilePath;
	string		aDestFolderPath;
	BFile		aDestFile;

	// 解凍先フォルダの作成
	aDestFolderPath = oDestFolder;
	if ( aDestFolderPath[aDestFolderPath.length()-1] != '/' ) {
		aDestFolderPath += '/';
	}
	aDestFolderPath += ExtractFilePath(mLatestHdr->Name());
	if ( aDestFolderPath[aDestFolderPath.length()-1] != '/' ) {
		aDestFolderPath += '/';
	}
	create_directory(aDestFolderPath.c_str(),0777);
	// 解凍先ファイルを取得して解凍
	aDestFilePath = aDestFolderPath+ExtractFileName(mLatestHdr->Name());
	if ( aDestFile.SetTo(aDestFilePath.c_str(),B_READ_WRITE|B_CREATE_FILE|B_ERASE_FILE) != B_OK )
		return B_ERROR;
	aResult = Extract(&aDestFile);
	DBEXP("aDestFilePath - TLHAKernel::Extract",aDestFilePath);
	update_mime_info(aDestFilePath.c_str(),false,false,false);
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TLHAKernel::Extract(BPositionIO *oOutDest)
/* ''''''''''''''''''''''''''''''
GetHeader() した時の情報にしたがって、ファイルを oOutDest に解凍する
ヘッダの Name() は無視する
返値：成功したら B_OK、失敗したらそれ以外
   ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,, */
{
	int			aCrc;
	TMeltInfo	aMeltInfo(mLatestHdr);

	try {
		if ( (mLatestHdr->UnixMode() & UNIX_FILE_TYPEMASK) == UNIX_FILE_REGULAR ) {
			aCrc = DecodeLzhuf(mArc,oOutDest,&aMeltInfo);
			if ( mLatestHdr->HasCrc() && aCrc != mLatestHdr->Crc() )
				throw TException(B_ERROR);	// error("CRC error", aName);
		} else {
			throw TException(B_ERROR);	// error("Unknown information", aName);
		}
	} catch (TException oException) {
		return oException.ID();
	}
	return B_OK;
}
//------------------------------------------------------------------------------
string	TLHAKernel::ExtractFileName(const string &xFullPath)
{
	string::size_type	xDemiPos;	//'/'の位置
	string				xName;		//抜き出したファイル名（返値）

	xDemiPos = xFullPath.rfind("/");
	if ( xDemiPos == string::npos ) {	//パス無し
		xName = xFullPath;
	} else {
		xName = xFullPath.substr(xDemiPos+1);
	}
	return xName;
}
//------------------------------------------------------------------------------
string	TLHAKernel::ExtractFilePath(const string &xFullPath)
{
	string::size_type	xDemiPos;	//'/'の位置
	string				xPath;		//抜き出したパス（返値）

	xDemiPos = xFullPath.rfind("/");
	if ( xDemiPos == string::npos ) {	//パス無し
		xPath = "";
	} else {
		xPath = xFullPath.substr(0,xDemiPos+1);
	}
	return xPath;
}
//------------------------------------------------------------------------------
status_t	TLHAKernel::GetHeader(TLzhHeader *oHdr)
/* ''''''''''''''''''''''''''''''
続けて２回以上 GetHeader() を呼ばないこと
GetHeader() を呼んだ後は、Extract() か SeekNext() を呼ぶこと
   ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,, */
{
	status_t	aResult;

	aResult = oHdr->Scan(mArc);
	mLatestHdr = oHdr;
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TLHAKernel::SeekBegin()
{
	return mArc->Seek(0,SEEK_SET);
}
//------------------------------------------------------------------------------
status_t	TLHAKernel::SeekNext()
{
	return mArc->Seek(mLatestHdr->FrozenSize(),SEEK_CUR);
}
//------------------------------------------------------------------------------
status_t	TLHAKernel::SetTo(BPositionIO *oArc)
{
	mArc = oArc;
	return SeekBegin();
}
//------------------------------------------------------------------------------
void	TLHAKernel::UpdateCrc(unsigned char c,TMeltInfo *oMeltInfo)
{
	oMeltInfo->mRealCrc = oMeltInfo->mCrcTable[(oMeltInfo->mRealCrc ^ (c)) & 0xFF] ^ (oMeltInfo->mRealCrc >> CHAR_BIT);
}
//------------------------------------------------------------------------------
status_t	TLHAKernel::WriteCrc(unsigned char *p,int n,BPositionIO *oOutDest,TMeltInfo *oMeltInfo)
{
	CalcCrc(p,n,oMeltInfo);
	if ( oMeltInfo->mVerifyMode )	// 解凍時は mVerifyMode == false っぽい
		return B_OK;
	if ( oOutDest->Write(p,n) < n )
		throw TException(B_ERROR);	// fatal_error("File write error\n");
	return B_OK;
}
//==============================================================================

